 /*
 * ASSEGNAMENTO1-9:
 * Scrivere un programma che prende come argumenti un certo numero di stringhe
 * e le ordina alfanumericamente utilizzando la chiamata di libreria qsort (man 3 qsort).
 *
 * COMPILAZIONE:
 *  gcc -std=c99 -Wall -g ./stringsort.c -o stringsort
 *
 * TESTING:
 *   preparare un file con il comando cat nel modo seguente:
 *     $> cat << FINE > filediinput.txt
 *     > questa è la prima riga 
 *     > Questa è la seconda un più lunga
 *     > AAA questa è quella che deve finire per prima
 *     > jjj questa è prima della prima riga
 *     > zzz questa è ultima....
 *     > FINE
 *   quindi lanciare il comando :
 *     $> cat filediinput.txt | xargs -I {} echo \"{}\" | xargs ./stringsort
 *   e verificare che l'output sia correttamente ordinato.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int cmpstring(const void *str1, const void *str2)  {
    const size_t str1len = strlen(*(char**)str1);
    const size_t str2len = strlen(*(char**)str2);

    return strncmp(*(char**)str1, *(char**)str2, ((str1len<=str2len)?str1len:str2len));
}

int main(int argc, char *argv[]) {
    if (!--argc) {
	fprintf(stderr, "uage: %s <stringa1> <stringa2> ...... <stringaN>\n", argv[0]);
	return EXIT_FAILURE;
    }
    char **V = malloc(argc*sizeof(char*));
    if (!V) {
	perror("malloc");
	return EXIT_FAILURE;
    }
    for(int i=0;i<argc; ++i) {
	V[i] = calloc(1, strlen(argv[i+1])+1);
	if (!V[i]) {
	    perror("malloc");
	    return EXIT_FAILURE;
	}
	strncpy(V[i], argv[i+1], strlen(argv[i+1]));
    }
 
    printf("PRIMA:\n");
    for(int i=0;i<argc; ++i) 
	printf("V[%d]=%s\n", i, V[i]);
    
    qsort(&V[0],argc, sizeof(char*), cmpstring);

    printf("\nDOPO:\n");
    for(int i=0;i<argc; ++i) 
	printf("V[%d]=%s\n", i, V[i]);

    return 0;
}
    
